#include <windows.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

static char *below20[] = {
	"zero",
	"one",
	"two",
	"three",
	"four",
	"five",
	"six",
	"seven",
	"eight",
	"nine",
	"ten",
	"eleven",
	"twelve",
	"thirteen",
	"fourteen",
	"fifteen",
	"sixteen",
	"seventeen",
	"eighteen",
	"nineteen"
};
static char *tens[] = {
	"zero",
	"ten",
	"twenty",
	"thirty",
	"forty",
	"fifty",
	"sixty",
	"seventy",
	"eighty",
	"ninety"
};

void hundredstr(int n, LPSTR str)
{
	int hun, rem;
	hun = n/100;
	rem = n % 100;
	if (hun > 0) {
		lstrcat(str, below20[hun]);
		lstrcat(str, " hundred");
	}
	if (rem > 0) {
		if (hun > 0 ) {
			lstrcat(str, " ");
		}
		if (rem < 20) {
			lstrcat(str, below20[rem]);
		}
		else {
			lstrcat(str, tens[rem/10]);
			if (rem % 10) {
				lstrcat(str, " ");
				lstrcat(str, below20[rem%10]);
			}
		}
	}
}


// OV argument template = "FBF"
LPSTR FAR PASCAL _export DollarString(double dbldlr, LPSTR str)
{
	unsigned long l;
	int mil, tho, hun, cents;
	char buf[4];
	*str = '\0';
	if (dbldlr > 42949672.94 || dbldlr < 0.0) {
		return str;
	}
	/* use fcvt() to avoid inaccuracies which may result from
	   truncation when double is converted by assignment to long.
	   dbldlr is assumed to have only two valid decimal places.  Note
	   that .015 will be converted to .01 not .02 BUT .025 will
	   be converted to .03. Strange but true.
	*/
	l = (unsigned long) atol(fcvt(dbldlr, 2, &hun, &cents));
	cents = (int) (l % 100L);
	l = l/100L;
	mil = (int) (l / 1000000L);
	l = l % 1000000L;
	tho = (int) (l / 1000L);
	hun = l % 1000L;
	if (mil > 0) {
		hundredstr(mil, str);
		lstrcat(str, " million ");
	}
	if (tho > 0) {
		hundredstr(tho, str);
		lstrcat(str, " thousand ");
	}
	if (hun > 0) {
		hundredstr(hun, str);
	}
	if (mil || tho || hun) {
		lstrcat(str, " and ");
	}
	itoa(cents, buf, 10);
	if (cents < 10) {
		lstrcat(str, "0");
	}
	lstrcat(str, (LPSTR)buf);
	lstrcat(str, "/100");
	return str;
}
